
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#ifdef XM
#include <Xm/Xm.h>
#include <Xm/Label.h>
#include <Xm/MenuButton.h>
#include <Xm/SimpleMenu.h>
#include <Xm/Form.h>
#include <Xm/Box.h>
#include <Xm/Command.h>
#else
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>

#include <X11/Xaw/Form.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <unistd.h>

int QMpid=-1;

Widget  bitMap;

static Widget topLevel, form;
static XtAppContext app_context;
static XImage *image = NULL;
static GC gc;
static Pixmap pixmap;
static char *buf;
static int colors[8];
static int black,white;
static Cursor cursor;
static Pixmap empty;

#if 0
static void allocColours(Widget w)
{
    Colormap map;
    static char *Cname[]={"Red","Green","white"};
    static char *Gname[]={"gray30","gray60","gray95"};
    char **name;
    int screen = XDefaultScreen (XtDisplay(w));  
    XColor exact_def;
    int default_depth=DefaultDepth(XtDisplay(w), screen);
    int res,i=5;

    XVisualInfo visual_info;
    
    static char *visual_class[]={"StaticGray","GrayScale","StaticColor",
			       "PseudoColor","TrueColor","DirectColor"};

    map=DefaultColormap(XtDisplay(w), screen);
    XSetWindowColormap(XtDisplay(w), XtWindow(w), map);

    if (default_depth<4)  {
	printf("sorry, not much support fo monochrome display\n");
	colors[0]=colors[1]=black;
	colors[2]=colors[3]=white;
	colors[4]=colors[5]=black;
	colors[6]=colors[7]=white;
  }  

    while(!XMatchVisualInfo(XtDisplay(w), screen, 
			    default_depth, i--, &visual_info));
  

	name=Cname;


#define MAXCOLORS 3
 
  
	printf("Default Visual %s\n",
	       visual_class[DefaultVisual(XtDisplay(w),screen)->class]); 
  
    colors[0]=colors[1]=BlackPixel(XtDisplay(w), screen);
    colors[7]=colors[6]=WhitePixel(XtDisplay(w), screen);  
    
    for(i=0; i<MAXCOLORS; i++)
    {
	res=XParseColor(XtDisplay(w), map, name[i], &exact_def);
	res=XAllocColor(XtDisplay(w), map, &exact_def);
	colors[2*(i+1)]=colors[2*(i+1)+1]=exact_def.pixel;
    }
}
#endif

void sendQM(long sig)
{
  kill(QMpid, sig);
}






static int self;

void ontsignal(XtPointer p, XtIntervalId *id)
{
#if 1
  /*sendQM(SIGALRM);*/
  /*XtAppAddTimeOut(app_context, 20, ontsignal, NULL);*/
#endif
}

/* Action Routines */
#include "buttonactions.c"
 



on_fat_int()
{
  sendQM(SIGUSR1);
#if 0
  sendQM(SIGINT);
#endif
  exit(1);
}

oncc()
{
  sendQM(SIGUSR1);
  sendQM(SIGINT);
  exit(0);
}




void init_signals()
{
  struct sigaction sac;
  long i;


  sigemptyset(&(sac.sa_mask));
  sac.sa_flags=0;

#ifndef NSIG
#define NSIG _NSIG
#endif

  for(i=1; i<=SIGUSR2;i++)
    {
      sac.sa_handler=oncc;
      sigaction(i,&sac,NULL);
    }
  sac.sa_handler=on_fat_int;
  sigaction(SIGSEGV,&sac,NULL);
  sigaction(SIGBUS,&sac,NULL);
  sigaction(SIGILL,&sac,NULL);
}



int main (int ac, char **av)
{
    Widget label,button;
    static Arg Lbldef [] =
    {
      	{XtNjustify,   XtJustifyCenter},
	{XtNinternalHeight, 0},
	{XtNborderWidth, 0},
	{XtNleft, XawChainLeft},
	{XtNright, XawChainRight},
	{XtNtop, XawChainTop},
	{XtNbottom, XawChainTop}
    };

    QMpid=atol(av[1]);

    topLevel = XtVaAppInitialize (&app_context,   /* Application context */
				  "Xql",   /* Application class */
				  NULL, 0,
				  &ac, av,
				  NULL,   /* for missing app-defaults file */
				  NULL);  /* terminate varargs list */

    form = XtCreateManagedWidget("form", 
				 boxWidgetClass, topLevel, 
				 NULL, 0);

#if 1
#include  "buttons.c"
#else
    button = XtCreateManagedWidget("Exit", 
				     commandWidgetClass, form, 
				      NULL, 0);

    XtAddCallback(button,  XtNcallback, Quit, NULL);


    label = XtCreateManagedWidget("UQLX", 
				  labelWidgetClass, form, 
				  Lbldef, XtNumber(Lbldef));
#endif

    /*XtAppAddTimeOut(app_context, 20, ontsignal, NULL);*/
    XtRealizeWidget (topLevel);
 
    init_signals();
    /*init_timers();*/

    XtSetKeyboardFocus(topLevel, bitMap);

    XtAppMainLoop (app_context);
    return 0;
}
