#include "QLtypes.h"
#include "QL68000.h"
#include "QL_config.h"
#include "QInstAddr.h"





/* table of ISO-latin1 -> QL translations*/
static struct  
{
  int iso; 
  int ql;
} codetable[] =
  {
    {96,159},

    {161,179},
    {162,157},
    {163,96},
    {164,183},
    {165,158},
    {167,182},
    {169,127},
    {171,184},
    {176,186},
    {180,159},
    {181,176},
    {187,185},
    {191,180},
    
    {197,162},
    {196,160},
    {195,161},
    {198,170},
    {199,168},
    {201,163},
    {214,164},
    {213,165},
    {216,166},
    {220,167},
    {223,156},
    {224,141},
    {233,131},
    {227,129},
    {228,128},
    {229,130},
    {230,138},
    {231,136},
    {232,144},
    {234,145},
    {236,148},
    {237,147},
    {238,149},
    {239,146},
    {240,173},
    {241,137},
    {242,151},
    {243,150},
    {244,152},
    {246,132},
    {247,187},
    {248,134},
    {249,154},
    {250,153},
    {251,155},
    {252,135},
    
    {0,0}  
  };


/* very simple method to convert iso to ql chars*/
static unsigned char x__iso2ql(unsigned c)
{
  int i;
  
  for(i=0; codetable[i].iso!=0; i++)
    if (codetable[i].iso==c)
      return codetable[i].ql;
  return c;
}
static unsigned char x__ql2iso(unsigned c)
{
  int i;
  
  for(i=0; codetable[i].iso!=0; i++)
    if (codetable[i].ql==c)
      return codetable[i].iso;
  return c;
}



unsigned char i2q[256];
unsigned char q2i[256];


init_iso()
{
  int i;
  
  for(i=0;i<256;i++) i2q[i]=x__iso2ql(i);
  for(i=0;i<256;i++) q2i[i]=x__ql2iso(i);
}


int iso2ql(int c)
{
  return i2q[c];
}
int ql2iso(int c)
{
  return q2i[c];
}

int iso2ql_mem(unsigned char * buf,int len)
{
  while(len-->0)
    buf[len]=i2q[buf[len]];
}
int ql2iso_mem(unsigned char * buf,int len)
{
  while(len-->0)
    buf[len]=q2i[buf[len]];
}
