/* define memory access fns for the non USE_VM case */


#define ReadDispByte(_addr_) (*(uw8 *)((Ptr)theROM+((long)_addr_)))

INLINE w8 ReadByte(w32 addr)
{   
  register char c;


  addr&=ADDR_MASK;


  c=RamMap[addr>>15]&25 &(~(1<<2));
  if(c!=1)
    { 
#if 0
      if(c==17) return ReadDispByte(addr);
      else if(c==8) return ReadHWByte(addr);
      return 0;
#else
      if(c==8) return ReadHWByte(addr);
      return 0;
#endif
    }
  return *((w8*)theROM+addr);
}



#define ReadDispWord(__addr__) RW((uw16*)((Ptr)theROM+((long)__addr__)))
INLINE w16 ReadWord(w32 addr)
{   
  register char c;

  if(((char)addr&1)!=0)
    {   
      exception=3;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      badAddress=addr;
      readOrWrite=16;
      return 0;
    }
  addr&=ADDR_MASK_E;

  c=RamMap[addr>>15]&25 &(~(1<<2));
  if(c!=1)
    { 
#if 0
      if(c==17) return ReadDispWord(addr);
      else if(c==8) 
	return ((w16)ReadHWByte(addr)<<8)|(uw8)ReadHWByte(addr+1);
      return 0;
#else
      if(c==8) 
	return ((w16)ReadHWByte(addr)<<8)|(uw8)ReadHWByte(addr+1);
      return 0;
#endif
    }
  return RW((w16*)((Ptr)theROM+addr));
}



#define ReadDispLong(_adr_) (RL((Ptr)theROM+((long)_adr_)))
INLINE w32 ReadLong(w32 addr)
{   
  register char c;

  if(((char)addr&1)!=0)
    { 
      exception=3;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      badAddress=addr;
      readOrWrite=16;
      return 0;
    }
  addr&=ADDR_MASK_E;

  c=RamMap[addr>>15]&25 &(~(1<<2));
  if(c!=1)
    { 
#if 0
      if(c==17) return ReadDispLong(addr);
      else if(c==8) 
	return ((w32)ReadWord(addr)<<16)|(uw16)ReadWord(addr+2);
      return 0;
#else
      if(c==8) 
	return ((w32)ReadWord(addr)<<16)|(uw16)ReadWord(addr+2);
      return 0;
#endif
    }
  return  RL((Ptr)theROM+addr); /* *((w32*)((Ptr)theROM+addr));*/
}


INLINE  void WriteInt(w8 d)
{   
  intReg=d;
}




#define ValidateDispByte(_xx) 
#ifdef DEBUG
long watchaddr=0;
#endif
INLINE void WriteByte(w32 addr,w8 d)
{   
  register char c;

  addr&=ADDR_MASK;

#ifdef DEBUG
  if (addr==watchaddr)dbginfo("write byte %d to watchaddr=%x",d,addr);
#endif
  c=RamMap[addr>>15]&30;
  if(c!=2)
    { 
#ifndef VM_SCR
      if(c==6)
#if 0
	goto wDisp;
      if(c==22)
#endif
	{ 
#ifdef MARK_SCREEN
	wDisp:
	  vmMarkScreen(addr);
	  *((w8*)theROM+addr)=d;
#else
	wDisp:
          *((w8*)theROM+addr)=d;
	  addr&=ADDR_MASK_E;
	  if(addr==displayTo+2 || addr==displayTo) 
	    displayTo=addr;
	  else
	    { 
	      if(displayFrom<=addr)
		{ 
		  if(displayFrom==0)
		    displayFrom=displayTo=addr;
		  else
		    { 
		      if(displayTo>=addr) return;
		      FlushDisplay();
		      displayFrom=displayTo=addr;
		    }
		}
	      else
		{ 
		  if(displayFrom-2==addr)
		    displayFrom=addr;
		  else
		    { 
		      FlushDisplay();
		      displayFrom=displayTo=addr;
		    }
		}
	    }
#endif /* USE_VM */
	}
      else 
#endif  /* VM_SCR */
	if(c==8)
	{ 
	  /*printf("write HWreg at %x val=%x\n",addr-0x18000,d);*/
	  
	  switch(addr) {
	  case 0x018063:  /* Display control */
	    SetDisplay(d,true);
	  case 0x018000:
	  case 0x018001:
	    /* ignore write to real-time clock registers */
	  case 0x018023:
	    /* ignore write to no reg */
	    break;
	  case 0x018002:
	    if(d!=16)
	      { 
		debug2("Write to transmit control >",d);
		debug2("at pc-2 ",(Ptr)pc-(Ptr)theROM-2);
		/*TRR;*/
	      }
	    break;
	  case 0x018003:
	    debugIPC("Write to IPC link > ",d);
	    debugIPC("at (PC-2) ",(Ptr)pc-(Ptr)theROM-2);
	    /*TRR;*/
	    break;
	  case 0x018020: WriteMdvControl(d); /*TRR;*/ break;
	  case 0x018021: WriteInt(d); break;
	  case 0x018022: debug2("Write to MDV/RS232 data >",d); /*TRR;*/ break;
	  default:  debug2("Write to HW register ",addr);
                    debug2("at (PC-2) ",(Ptr)pc-(Ptr)theROM-2);
		    /*TRR;*/
	    break;
	  }
	}
#ifdef DEBUG
      else dbginfo("WARNING: writing to ROM,addr=%x val=%d\n",addr,d);
#endif
    }
  else *((w8*)theROM+addr)=d;
}




INLINE void WriteWord(w32 addr,w16 d)
{   
  register char c;

  if(((char)addr&1)!=0)
    { 
      exception=3;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      badAddress=addr;
      readOrWrite=0;
      return;
    }
  addr&=ADDR_MASK_E;

#ifdef DEBUG
  if (addr==watchaddr)dbginfo("write word %d to watchaddr=%x",d,addr);
#endif
  c=RamMap[addr>>15]&14;
  if(c!=2)
    { 
      if(c==6)
	{       
	  /* *((w16*)((Ptr)theROM+addr))=d; */
#if defined(MARK_SCREEN)
	  vmMarkScreen(addr);
#endif
	  WW((Ptr)theROM+addr,d);
#if !defined(VM_SCR) && !defined(MARK_SCREEN)
	  if(addr==displayTo+2) displayTo=addr;
	  else
	    { 
	      if(displayFrom<=addr)
		{ 
		  if(displayFrom==0)
		    displayFrom=displayTo=addr;
		  else
		    { 
		      if(displayTo>=addr) return;
		      FlushDisplay();
		      displayFrom=displayTo=addr;
		    }
		}
	      else
		{ 
		  if(displayFrom-2==addr)
		    displayFrom=addr;
		  else
		    { 
		      FlushDisplay();
		      displayFrom=displayTo=addr;
		    }
		}
	    }
#endif
	}
      else if(c==8)
	{ 
	  WriteByte(addr,d>>8);
	  WriteByte(addr+1,d&255);
	}
#ifdef DEBUG
      else dbginfo("WARNING: writing to ROM, addr=%x va=%d\n",addr,d);
#endif
    }
  else WW((Ptr)theROM+addr,d);/* *((w16*)((Ptr)theROM+addr))=d; */
}




INLINE void WriteLong(w32 addr,w32 d)
{    
  register char c;

  if(((char)addr&1)!=0)
    { 
      exception=3;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      badAddress=addr;
      readOrWrite=0;
      return;
    }
  addr&=ADDR_MASK_E;

#ifdef DEBUG
  if (addr==watchaddr)dbginfo("write long %d to watchaddr=%x",d,addr);
#endif
  c=RamMap[addr>>15]&14;
  if(c!=2)
    { 
      if(c==6)
	{ 
#if defined(MARK_SCREEN)
	  vmMarkScreen(addr);
#endif
	  WL((Ptr)theROM+addr,d);
#if !defined(VM_SCR) && !defined(MARK_SCREEN)
	  if(addr==displayTo+2 || addr==displayTo)
	    displayTo=addr+2;
	  else
	    { 
	      if(displayFrom<=addr)
		{ 
		  if(displayFrom==0)
		    { 
		      displayFrom=addr;
		      displayTo=addr+2;
		      return;
		    }
		  else
		    { 
		      if(displayTo>addr) return;
		      FlushDisplay();
		      displayFrom=addr;
		      displayTo=addr+2;
		      return;
		    }
		}
	      else
		{ 
		  if(displayFrom-4<=addr)
		    displayFrom=addr;
		  else
		    { 
		      FlushDisplay();
		      displayFrom=addr;
		      displayTo=addr+2;
		    }
		}
	    }
#endif
	}
      else if(c==8)
	{ 
	  WriteWord(addr,d>>16);
	  WriteWord(addr+2,(uw16)d);
	}
#ifdef DEBUG
      else {dbginfo("WARNING: writing to ROM, addr=%x, val=%d\n",addr,d);}
#endif
    }
  else  WL((Ptr)theROM+addr,d);           
  /* *((w32*)((Ptr)theROM+addr))=d;*/
}




static isreg=0;

w8 ModifyAtEA_b(short mode,short r)
{   
  w16 displ;
  w32     addr;
  switch(mode) {
  case 0:
#if !defined(VM_SCR) 
    isDisplay=false;
#endif
    isHW=false;
    dest=(Ptr)(&reg[r])+RBO;
    return *((w8*)dest);
  case 2:addr=aReg[r];
    break;
  case 3:addr=aReg[r]++;
    if(r==7) (*sp)++;
    break;
  case 4:
    if(r==7) (*sp)--;
    addr=--aReg[r];
    break;
  case 5:addr=aReg[r]+(w16)RW(pc++);
    break;
  case 6:
    displ=(w16)RW(pc++);
    if((displ&2048)!=0) addr=reg[(displ>>12) & 15]+
			  aReg[r]+(w32)((w8)displ);
    else addr=(w32) ((w16)(reg[(displ>>12) & 15]))+
	   aReg[r]+(w32)((w8)displ);
    break;
  case 7:
    switch(r) {
    case 0:addr=(w16)RW(pc++);
      break;
    case 1:addr=RL((w32*)pc);
      pc+=2;
      break;
    default:
      exception=4;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      isHW=false;
#if !defined(VM_SCR) 
      isDisplay=false;
#endif
      dest=(Ptr)(&dummy);
      return 0;
    }
    break;
  default:
    exception=4;
    extraFlag=true;
    nInst2=nInst;
    nInst=0;
    isHW=false;
#if !defined(VM_SCR) 
    isDisplay=false;
#endif
    dest=(Ptr)(&dummy);
    return 0;
  }
#if 1
  addr&=ADDR_MASK;
#endif
  switch(RamMap[addr>>15]) {
  case 1:isHW=false;
#if !defined(VM_SCR) 
    isDisplay=false;
#endif
    dest=(Ptr)(&dummy);
    return *((w8*)theROM+addr);
  case 3:isHW=false;
#if !defined(VM_SCR) 
    isDisplay=false;
#endif
    dest=(Ptr)theROM+addr;
    return *((w8*)dest);
  case 7:isHW=false;
#if !defined(VM_SCR) 
    isDisplay=true;
#endif
    dest=(Ptr)theROM+addr;
#ifndef VM_SCR
    lastAddr=addr;
#endif
    return *((w8*)dest);
  case 23:isHW=false;
#if !defined(VM_SCR) 
    isDisplay=true;
#endif
    dest=(Ptr)theROM+addr;
#ifndef VM_SCR
    lastAddr=addr;
#endif
    return *((w8*)dest);
  case 8:isHW=true;
#if !defined(VM_SCR)
    isDisplay=false;
    lastAddr=addr;
#endif
    dest=(Ptr)(&dummy);
    return ReadByte(addr);
  }
  isHW=false;
#if !defined(VM_SCR)
  isDisplay=false;
#endif
  dest=(Ptr)(&dummy);
  return 0;
}

w16 ModifyAtEA_w(short mode,short r)
{  
  w16 displ,tmp;
  w32     addr;
#ifndef BIG_ENDIAN
  isreg=0;
#endif
  switch(mode) {
  case 0:
#if !defined(VM_SCR) 
    isDisplay=false;
#endif
    isHW=false;
    dest=(Ptr)(&reg[r])+RWO;
#ifndef BIG_ENDIAN
    isreg=1;
#endif
    return *((w16*)dest);
  case 1:
#if !defined(VM_SCR) 
    isDisplay=false;
#endif
    isHW=false;
#ifndef BIG_ENDIAN
    isreg=1;
#endif
    dest=(Ptr)(&aReg[r])+RWO;
    return *((w16*)dest);
  case 2:addr=aReg[r];
    break;
  case 3:addr=aReg[r];
    aReg[r]+=2;
    break;
  case 4:addr=(aReg[r]-=2);
    break;
  case 5:addr=aReg[r]+(w16)RW(pc++);
    break;
  case 6:
    displ=(w16)RW(pc++);
    if((displ&2048)!=0) addr=reg[(displ>>12) & 15]+
			  aReg[r]+(w32)((w8)displ);
    else addr=(w32)((w16)(reg[(displ>>12) & 15]))+
	   aReg[r]+(w32)((w8)displ);
    break;
  case 7:
    switch(r) {
    case 0:addr=(w16)RW(pc++);
      break;
    case 1:addr=RL((w32*)pc);
      pc+=2;
      break;
    default:
      exception=4;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      isHW=false;
#if !defined(VM_SCR) 
      isDisplay=false;
#endif
      dest=(Ptr)(&dummy);
      return 0;
    }
    break;
  }
  if(((short)addr&1)!=0)
    { 
      exception=3;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      badAddress=addr;
      readOrWrite=16;
      isHW=false;
#if !defined(VM_SCR) 
      isDisplay=false;
#endif
      dest=(Ptr)(&dummy);
      return 0;
    }
#if 1
  addr&=ADDR_MASK_E;
#endif
  switch(RamMap[addr>>15]) {
  case 1:isHW=false;
#if !defined(VM_SCR) 
    isDisplay=false;
#endif
    dest=(Ptr)(&dummy);
    return RW((w16*)((Ptr)theROM+addr));
  case 3:isHW=false;
#if !defined(VM_SCR) 
    isDisplay=false;
#endif
    dest=(Ptr)theROM+addr;
    return RW((w16*)dest);
  case 7:isHW=false;
#if !defined(VM_SCR) 
    isDisplay=true;
    lastAddr=addr;
#endif
    dest=(Ptr)theROM+addr;
    return RW((w16*)dest);
  case 23:isHW=false;
#if !defined(VM_SCR)
    isDisplay=true;
    lastAddr=addr;
#endif
    dest=(Ptr)theROM+addr;
    tmp=ReadDispWord(addr);
    return tmp;
  case 8:isHW=true;
#if !defined(VM_SCR) 
    isDisplay=false;
    lastAddr=addr;
#endif
    dest=(Ptr)(&dummy);
    return ReadWord(addr);
  }
  isHW=false;
#if !defined(VM_SCR) 
  isDisplay=false;
#endif
  dest=(Ptr)(&dummy);
  return 0;
}

w32 ModifyAtEA_l(short mode,short r)
{   
  w16 displ;
  w32     addr,tmp;

  isreg=0;
  switch(mode) {
  case 0:
#if !defined(VM_SCR) 
    isDisplay=false;
#endif
    isHW=false;
    isreg=1;
    dest=(Ptr)(&reg[r]);
    return *((w32*)dest);
  case 1:
#if !defined(VM_SCR) 
    isDisplay=false;
#endif
    isHW=false;
    isreg=1;
    dest=(Ptr)(&aReg[r]);
    return *((w32*)dest);
  case 2:addr=aReg[r];
    break;
  case 3:addr=aReg[r];
    aReg[r]+=4;
    break;
  case 4:addr=(aReg[r]-=4);
    break;
  case 5:addr=aReg[r]+(w16)RW(pc++);
    break;
  case 6:
    displ=(w16)RW(pc++);
    if((displ&2048)!=0) addr=reg[(displ>>12) & 15]+
			  aReg[r]+(w32)((w8)displ);
    else addr=(w32)((w16)(reg[(displ>>12) & 15]))+
	   aReg[r]+(w32)((w8)displ);
    break;
  case 7:
    switch(r) {
    case 0:addr=(w16)RW(pc++);
      break;
    case 1:addr=RL((w32*)pc);
      pc+=2;
      break;
    default:
      exception=4;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      isHW=false;
#if !defined(VM_SCR)
      isDisplay=false;
#endif
      dest=(Ptr)(&dummy);
      return 0;
    }
    break;
  }
  if(((short)addr&1)!=0)
    { 
      exception=3;
      extraFlag=true;
      nInst2=nInst;
      nInst=0;
      badAddress=addr;
      readOrWrite=16;
      isHW=false;
#if !defined(VM_SCR) 
      isDisplay=false;
#endif
      dest=(Ptr)(&dummy);
      return 0;
    }
#if 1
  addr&=ADDR_MASK_E;
#endif
  switch(RamMap[addr>>15]) {
  case 1:isHW=false;
#if !defined(VM_SCR)
    isDisplay=false;
#endif
    dest=(Ptr)(&dummy);
    return RL((w32*)((Ptr)theROM+addr));
  case 3:isHW=false;
#if !defined(VM_SCR)
    isDisplay=false;
#endif
    dest=(Ptr)theROM+addr;
    return RL((w32*)dest);/* *((w32*)dest);*/
  case 7:isHW=false;
#if !defined(VM_SCR) 
    isDisplay=true;
    lastAddr=addr;
#endif
    dest=(Ptr)theROM+addr;
    return RL((w32*)dest);
  case 23:isHW=false;
#if !defined(VM_SCR) 
    isDisplay=true;
    lastAddr=addr;
#endif
    dest=(Ptr)theROM+addr;
    tmp=ReadDispLong(addr);
    return tmp;
  case 8:isHW=true;
#if !defined(VM_SCR) 
    isDisplay=false;
    lastAddr=addr;
#endif
    dest=(Ptr)(&dummy);
    return ReadLong(addr);
  }
  isHW=false;
#if !defined(VM_SCR) 
  isDisplay=false;
#endif
  dest=(Ptr)(&dummy);
  return 0;
}

void RewriteEA_b(w8 d)
{   
  if(isHW) WriteByte(lastAddr,d);
  else
    { 
#if defined(MARK_SCREEN)
      if(isDisplay)
	vmMarkScreen((char*)dest-(char*)theROM);
#endif
      *((w8*)dest)=d;
#if !defined(VM_SCR) && !defined(MARK_SCREEN)
      if(isDisplay)
	{ 
	  lastAddr&=ADDR_MASK_E;
	  if(lastAddr==displayTo+2 || lastAddr==displayTo)
	    displayTo=lastAddr;
	  else
	    { 
	      if(displayFrom<=lastAddr)
		{ 
		  if(displayFrom==0)
		    displayFrom=displayTo=lastAddr;
		  else
		    { 
		      if(displayTo>=lastAddr) return;
		      FlushDisplay();
		      displayFrom=displayTo=lastAddr;
		    }
		}
	      else
		{ 
		  if(displayFrom-2==lastAddr)
		    displayFrom=lastAddr;
		  else
		    { 
		      FlushDisplay();
		      displayFrom=displayTo=lastAddr;
		    }
		}
	    }
	}
#endif
    }
}

void RewriteEA_w(w16 d)
{  
  if(isHW) WriteWord(lastAddr,d);
  else
    {  
      /* *((w16*)dest)=d; */
#if defined(MARK_SCREEN)
      if(isDisplay)
	vmMarkScreen((char*)dest-(char*)theROM);
#endif
#ifndef BIG_ENDIAN
      if (isreg) *((w16*)dest)=d;
      else WW((Ptr)dest,d);
#else
      WW((Ptr) dest,d); 
#endif

#if !defined(VM_SCR) && !defined(MARK_SCREEN)
      if(isDisplay)
	{ 
	  if(lastAddr==displayTo+2) displayTo=lastAddr;
	  else
	    { 
	      if(displayFrom<=lastAddr)
		{ 
		  if(displayFrom==0)
		    displayFrom=displayTo=lastAddr;
		  else
		    { 
		      if(displayTo>=lastAddr) return;
		      FlushDisplay();
		      displayFrom=displayTo=lastAddr;
		    }
		}
	      else
		{ 
		  if(displayFrom-2==lastAddr)
		    displayFrom=lastAddr;
		  else
		    { 
		      FlushDisplay();
		      displayFrom=displayTo=lastAddr;
		    }
		}
	    }
	}
#endif
    }
}

void RewriteEA_l(w32 d)
{    
  if(isHW) WriteLong(lastAddr,d);
  else
    { 
#if defined(MARK_SCREEN)
      if(isDisplay)
	vmMarkScreen((char*)dest-(char*)theROM);
#endif
#ifndef BIG_ENDIAN
      if (isreg) *((w32*)dest)=d;
      else WL((Ptr)dest,d);
#else
      WL((Ptr)dest,d);
#endif 
#if !defined(VM_SCR) && !defined(MARK_SCREEN)
      if(isDisplay)
	{
	  if(lastAddr==displayTo+2 || lastAddr==displayTo)
	    displayTo=lastAddr+2;
	  else
	    {  
	      if(displayFrom<=lastAddr)
		{ 
		  if(displayFrom==0)
		    { 
		      displayFrom=lastAddr;
		      displayTo=lastAddr+2;
		      return;
		    }
		  else
		    { 
		      if(displayTo>lastAddr) return;
		      FlushDisplay();
		      displayFrom=lastAddr;
		      displayTo=lastAddr+2;
		      return;
		    }
		}
	      else
		{ 
		  if(displayFrom-4<=lastAddr)
		    displayFrom=lastAddr;
		  else
		    { 
		      FlushDisplay();
		      displayFrom=lastAddr;
		      displayTo=lastAddr+2;
		    }
		}
	    }
	}
#endif
    }
}

