/* UQLX  */
/* fucntions to translate C68 to/from HOST constants and options */

#include "xc68.h"

int c68err(int err)
{
  switch(err)
    {
      EALREADY : return C68ERR_EALREADY;
      ENOTSOCK : return C68ERR_ENOTSOCK;
      EDESTADDRREQ     : return C68ERR_EDESTADDRREQ;
      EMSGSIZE         : return C68ERR_EMSGSIZE;
      EPROTOTYPE       : return C68ERR_EPROTOTYPE;
      ENOPROTOOPT : return C68ERR_ENOPROTOOPT;
      ESOCKTNOSUPPORT : return C68ERR_ESOCKTNOSUPPORT;
      EPFNOSUPPORT : return C68ERR_EPFNOSUPPORT;
      EAFNOSUPPORT  : return C68ERR_EAFNOSUPPORT;
      EADDRINUSE  : return C68ERR_EADDRINUSE;
      EADDRNOTAVAIL  : return C68ERR_EADDRNOTAVAIL;
      ENETDOWN  : return C68ERR_ENETDOWN;
      ENETRESET  : return C68ERR_ENETRESET;
      ECONNABORTED  : return C68ERR_ECONNABORTED;
      ECONNRESET  : return C68ERR_ECONNRESET;
      ENOBUFS  : return C68ERR_ENOBUFS;
      ENOTCONN  : return C68ERR_ENOTCONN;
      ESHUTDOWN : return C68ERR_ESHUTDOWN;
      ETOOMANYREFS : return C68ERR_ETOOMANYREFS;
    default: return 0;
    }
}

char *protoname(int proto)
{
  switch(proto)
    {
    case  C68_IPPROTO_IP   : return " dummy for IP ";
    case  C68_IPPROTO_ICMP : return " control message protocol ";
    case  C68_IPPROTO_GGP  : return " gateway^2 (deprecated) ";
    case  C68_IPPROTO_TCP  : return " tcp ";
    case  C68_IPPROTO_EGP  : return " exterior gateway protocol ";
    case  C68_IPPROTO_PUP  : return " pup ";
    case  C68_IPPROTO_UDP  : return " user datagram protocol ";
    case  C68_IPPROTO_IDP  : return " xns idp ";
    case  C68_IPPROTO_TP   : return " tp-4 w/ class negotiation ";
    case  C68_IPPROTO_EON  : return " ISO cnlp ";
    case  C68_IPPROTO_RAW  : return " raw IP packet ";
  default : return "unknown protocol";
  }
  
}


/* dummy fns, sometimes it should do all translations*/
xso_q2x(int level,int optname, void* optval,int len)
{
  char *proto;
  
  proto=protoname(level);
  
  printf("xso_q2x: proto %d %s, optname %d\n",level,proto,optname);
}
xso_x2q(int level,int optname, void* optval,int len)
{
  char *proto;
  
  proto=protoname(level);
  
  printf("xso_q2x: proto %d %s, optname %d\n",level,proto,optname);
}

